/*
 * This file is a part of DHCP client for TOPPERS/ASP w/ TINET
 * Copyright 2012(C) by A.GOTANDA
 */

#include <itron.h>
#include <netinet/in.h>

#define DHCPS_PORTNO	67
#define DHCPC_PORTNO	68

#define	DHCPC_MAIN_PRIORITY	 5	/* ᥤ󥿥ͥ
					   HIGH_PRIORITY ⤯뤳 */
#define DHCPC_HIGH_PRIORITY	 9	/* ˼¹Ԥ륿ͥ */
#define DHCPC_MID_PRIORITY	10
#define DHCPC_LOW_PRIORITY	11

#define DHCPC_STACK_SIZE	1024


#ifndef _MACRO_ONLY

extern void	dhcpc_MainTask(intptr_t exinf);
extern void	dhcpc_ReceiveTask(intptr_t exinf);
extern void	dhcpc_MessageTask(intptr_t exinf);
extern void	dhcpc_cyclic_handler(intptr_t exinf);

extern ER	dhcpc_callback(ID cepid, FN fncd, VP p_parblk);


#ifndef DEF_DHCP_GOT_ADDR_INFO
#define DEF_DHCP_GOT_ADDR_INFO

struct dhcp_got_addr_info {
    uint32_t	lease_time, renewal_time, rebinding_time;
    T_IN4_ADDR	server_id, addr, mask, gw, dns, log, ntps;
};
#endif /* DEF_DHCP_GOT_ADDR_INFO */
extern struct dhcp_got_addr_info dhcp_assigned, dhcp_received;

/*
 * DHCP ˤ address γơstate ѲΤ flag
 * DHCPC_STATE_CHG_FLAGSˤ bit pattern
 */
#define	DHCPC_FLG_ADDR_ASSIGNED		0x0001
#define	DHCPC_FLG_ADDR_EXPIRED		0x0002
#define	DHCPC_FLG_STATE_CHANGED		0x0004

#define	DHCPC_FLG_ADDR_CHANGED	\
		(DHCPC_FLG_ADDR_ASSIGNED | DHCPC_FLG_ADDR_EXPIRED)
#define	DHCPC_FLG_STATUS_CHANGED	\
		(DHCPC_FLG_ADDR_ASSIGNED | DHCPC_FLG_ADDR_EXPIRED \
		 | DHCPC_FLG_STATE_CHANGED)


extern int		dhcpc_get_state(void);
extern const char	*dhcpc_get_state_name(void);

#include "dhcp_state.h"

#endif /* _MACRO_ONLY */
